//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "CPortCtl"
#pragma resource "*.dfm"

// commande d'un afficheur LCD alphanumrique
// (C) Fabrice Sincre
// Borland Builder 5

TForm1 *Form1;

// variables globales
unsigned char tableau[2];
        // TX (RS232)  2 octets qui contiennent les niveaux logiques des 10 I/O
        // 1er octet transmis: tableau[0]       (000000 RS R/W)
        // 2me octet transmis : tableau[1]      (DB[7] ... DB[0])

int RS;
int RW;
int DB[8]; // DB[0] = DB0 ...

int ReadData;                 // drapeau
int index_transmission = 0;     // +1 quand transmission
                                // -1 quand rception
                                // si <0 ou >1 => erreur de transmission


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
StringGrid1->Cells[0][0] ="RS";
StringGrid1->Cells[1][0] ="R/W";
StringGrid1->Cells[2][0] ="DB7";
StringGrid1->Cells[3][0] ="DB6";
StringGrid1->Cells[4][0] ="DB5";
StringGrid1->Cells[5][0] ="DB4";
StringGrid1->Cells[6][0] ="DB3";
StringGrid1->Cells[7][0] ="DB2";
StringGrid1->Cells[8][0] ="DB1";
StringGrid1->Cells[9][0] ="DB0";

}

//---------------------------------------------------------------------------

void transmission (void)
{
// transmission de 2 octets (liaison RS232)

tableau[0]= 2*RS+ 1*RW;
tableau[1]= 128*DB[7]+ 64*DB[6] + 32*DB[5]+ 16*DB[4] + 8*DB[3] + 4*DB[2] +2*DB[1] + 1*DB[0];

Form1->ComPort1->Write(tableau, 2); //Ecrit les 2 octets sur le port srie
index_transmission ++;

if (index_transmission != 1)
{
        Application->MessageBox("Pas de signal de rception !", "Erreur RS232", MB_OK);
        index_transmission = 0;
}
return;
}

int conversionHex (AnsiString valeurHex)
{
   // cette fonction convertit valeurHex en dcimal
   // en cas de problme, la valeur de retour est  -1

   // test de validit de l'adresse hex.

        if (valeurHex.Length() != 2)
        {
                Application->MessageBox("Valeur hexadcimale non valide (2 chiffres) !","Erreur 01",MB_OK);
                return -1;
        }

        if (( valeurHex.SubString(1, 1) < "0" ||  valeurHex.SubString(1, 1) > "9" ) && (valeurHex.SubString(1, 1) <"A" || valeurHex.SubString(1, 1) >"F"))
        {
                Application->MessageBox("Valeur hexadcimale non valide !","Erreur 02",MB_OK);
                return -1;
        }
        if (((valeurHex.SubString(2, 1) <"0") || (valeurHex.SubString(2, 1) >"9")) && ((valeurHex.SubString(2, 1) <"A") || (valeurHex.SubString(2, 1) >"F")))
        {
                Application->MessageBox("Valeur hexadcimale non valide !","Erreur 03",MB_OK);
                return -1;
        }

        // conversion hexadcimal en dcimal

        int chiffre[2] ;
        int decimal ;
        int decimal0;

        for (int i=1; i<=2;i++)
        {
                if (valeurHex.SubString(i, 1) =="0") chiffre[2-i] = 0;
                if (valeurHex.SubString(i, 1) =="1") chiffre[2-i] = 1;
                if (valeurHex.SubString(i, 1) =="2") chiffre[2-i] = 2;
                if (valeurHex.SubString(i, 1) =="3") chiffre[2-i] = 3;
                if (valeurHex.SubString(i, 1) =="4") chiffre[2-i] = 4;
                if (valeurHex.SubString(i, 1) =="5") chiffre[2-i] = 5;
                if (valeurHex.SubString(i, 1) =="6") chiffre[2-i] = 6;
                if (valeurHex.SubString(i, 1) =="7") chiffre[2-i] = 7;
                if (valeurHex.SubString(i, 1) =="8") chiffre[2-i] = 8;
                if (valeurHex.SubString(i, 1) =="9") chiffre[2-i] = 9;
                if (valeurHex.SubString(i, 1) =="A") chiffre[2-i] = 10;
                if (valeurHex.SubString(i, 1) =="B") chiffre[2-i] = 11;
                if (valeurHex.SubString(i, 1) =="C") chiffre[2-i] = 12;
                if (valeurHex.SubString(i, 1) =="D") chiffre[2-i] = 13;
                if (valeurHex.SubString(i, 1) =="E") chiffre[2-i] = 14;
                if (valeurHex.SubString(i, 1) =="F") chiffre[2-i] = 15;
        }

        decimal = chiffre[1]*16 + chiffre[0] ;
return decimal;
}

void conversionDecBin (int ValeurDec, int nbbit)
{
 // nbbit : 8 max
 // conversion dcimal -> binaire
        for (int i=0 ; i < nbbit ; i++)
        {
                DB[i] = ValeurDec % 2 ; // reste de la division
                ValeurDec = ValeurDec /2 ;
        }
return;
}

void bitcommande (void)

{
Form1->StringGrid1->Cells[0][1] =RS;
Form1->StringGrid1->Cells[1][1] =RW;
Form1->StringGrid1->Cells[2][1] =DB[7];
Form1->StringGrid1->Cells[3][1] =DB[6];
Form1->StringGrid1->Cells[4][1] =DB[5];
Form1->StringGrid1->Cells[5][1] =DB[4];
Form1->StringGrid1->Cells[6][1] =DB[3];
Form1->StringGrid1->Cells[7][1] =DB[2];
Form1->StringGrid1->Cells[8][1] =DB[1];
Form1->StringGrid1->Cells[9][1] =DB[0];

return;
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
ComPort1->Connected=true; //Ouverture du port (prt  communiquer)

Button1 ->Enabled =false;
Button2 ->Enabled =true;
GroupBox1->Enabled =true;
Button9 ->Enabled =false;

GroupBoxSetFunction->Enabled = true ;
GroupBoxCursorOrDisplayShift->Enabled = false ;
GroupBoxReadAdressCounter->Enabled = false ;
ButtonDisplayClear->Enabled = false ;
ButtonReturnHome ->Enabled = false ;
GroupBoxEntryModeSet ->Enabled = false ;
GroupBoxDisplayOnOffControl ->Enabled = false ;
GroupBoxSetCGRAMadress ->Enabled = false ;
GroupBoxSetDDRAMadress ->Enabled = false ;
GroupBoxReadData ->Enabled = false ;
GroupBoxWriteDataRAM ->Enabled = false ;

ButtonSetFunction ->Enabled = true ;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
// Fermeture du port

ComPort1->Connected=false; //Fermeture du port (arrt des communications)
Button1 ->Enabled =true;
Button2 ->Enabled =false;
GroupBox1->Enabled =false;
Button9 ->Enabled =true;

ButtonSetFunction ->Enabled = false ;
ButtonCursorOrDisplayShift ->Enabled = false ;
ButtonReadAdressCounter ->Enabled = false ;
ButtonEntryModeSet ->Enabled = false ;
ButtonDisplayOnOffControl ->Enabled = false ;
ButtonSetCGRAMadress ->Enabled = false ;
ButtonSetDDRAMadress ->Enabled = false ;
ButtonWriteData ->Enabled = false ;
ButtonReadData  ->Enabled = false ;
ButtonDisplayClear->Enabled = false ;
ButtonReturnHome ->Enabled = false ;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button9Click(TObject *Sender)
{
ComPort1->ShowSetupDialog ();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonSetFunctionClick(TObject *Sender)
{
GroupBoxSetFunction->Enabled = false ;
GroupBoxCursorOrDisplayShift->Enabled = true ;
GroupBoxReadAdressCounter->Enabled = true ;
GroupBoxEntryModeSet ->Enabled = true ;
GroupBoxDisplayOnOffControl ->Enabled = true ;
GroupBoxSetCGRAMadress ->Enabled = true ;
GroupBoxSetDDRAMadress ->Enabled = true ;
GroupBoxReadData ->Enabled = true ;
GroupBoxWriteDataRAM ->Enabled = true ;

ButtonSetFunction ->Enabled = false ;
ButtonCursorOrDisplayShift ->Enabled = true ;
ButtonReadAdressCounter ->Enabled = true ;
ButtonEntryModeSet ->Enabled = true ;
ButtonDisplayOnOffControl ->Enabled = true ;
ButtonSetCGRAMadress ->Enabled = true ;
ButtonSetDDRAMadress ->Enabled = true ;
ButtonWriteData ->Enabled = true ;
ButtonReadData  ->Enabled = true ;
ButtonDisplayClear->Enabled = true ;
ButtonReturnHome ->Enabled = true ;

RS=0;
RW=0;
DB[7]=0;
DB[6]=0;
DB[5]=1;
DB[4]=0; // mode 4 bits

if (RadioGroupN->ItemIndex == 0) DB[3] = 0;
else DB[3] = 1;
if (RadioGroupF->ItemIndex == 0) DB[2] = 0;
else DB[2] = 1;

DB[1]=0;
DB[0]=0;
bitcommande();
transmission();


}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonDisplayClearClick(TObject *Sender)
{
// Display clear

RS=0;
RW=0;
DB[7]=0;
DB[6]=0;
DB[5]=0;
DB[4]=0;
DB[3]=0;
DB[2]=0;
DB[1]=0;
DB[0]=1;
bitcommande();
transmission();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReturnHomeClick(TObject *Sender)
{
// Return Home

RS=0;
RW=0;
DB[7]=0;
DB[6]=0;
DB[5]=0;
DB[4]=0;
DB[3]=0;
DB[2]=0;
DB[1]=1;
DB[0]=0;
bitcommande();
transmission();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonEntryModeSetClick(TObject *Sender)
{
RS=0;
RW=0;
DB[7]=0;
DB[6]=0;
DB[5]=0;
DB[4]=0;
DB[3]=0;
DB[2]=1;

if (RadioGroupID->ItemIndex == 0) DB[1] = 0;
else DB[1] = 1;

if (RadioGroupSH->ItemIndex == 0) DB[0] = 0;
else DB[0] = 1;
bitcommande();
transmission();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonDisplayOnOffControlClick(TObject *Sender)
{
RS=0;
RW=0;
DB[7]=0;
DB[6]=0;
DB[5]=0;
DB[4]=0;
DB[3]=1;

if (RadioGroupD->ItemIndex == 0) DB[2] = 0;
else DB[2] = 1;
if (RadioGroupC->ItemIndex == 0) DB[1] = 0;
else DB[1] = 1;
if (RadioGroupB->ItemIndex == 0) DB[0] = 0;
else DB[0] = 1;

bitcommande();
transmission();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonCursorOrDisplayShiftClick(TObject *Sender)
{
RS=0;
RW=0;
DB[7]=0;
DB[6]=0;
DB[5]=0;
DB[4]=1;

if (RadioGroupSC->ItemIndex == 0) DB[3] = 0;
else DB[3] = 1;
if (RadioGroupRL->ItemIndex == 0) DB[2] = 0;
else DB[2] = 1;

DB[1]=0;
DB[0]=0;
bitcommande();
transmission();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonSetCGRAMadressClick(TObject *Sender)
{
RS=0;
RW=0;
DB[7]=0;
DB[6]=1;

int valeur;
valeur = conversionHex (EditCGRAMadress->Text) ;
if (valeur == -1)
{
        EditCGRAMadress->Text = "00";
        return;
}
if (valeur >= 64)
{
        Application->MessageBox("L'adresse doit tre comprise entre 00 et 3F !","Erreur 01",MB_OK);
        EditCGRAMadress->Text = "00";
        return;
}
conversionDecBin (valeur, 6);

bitcommande();
transmission();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonSetDDRAMadressClick(TObject *Sender)
{
RS=0;
RW=0;
DB[7]=1;

int valeur;
valeur = conversionHex (EditSetDDRAMadress->Text) ;
if (valeur == -1)
{
        EditSetDDRAMadress->Text = "00";
        return;
}
if (valeur >= 128)
{
        Application->MessageBox("L'adresse doit tre comprise entre 00 et 7F !","Erreur 01",MB_OK);
        EditSetDDRAMadress->Text = "00";
        return;
}
conversionDecBin (valeur, 7);

bitcommande();
transmission();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonWriteDataClick(TObject *Sender)
{
RS=1;
RW=0;

int valeur;
valeur = conversionHex (EditWriteData->Text) ;
if (valeur == -1)
{
        EditWriteData->Text = "00";
        return;
}

conversionDecBin (valeur, 8);

bitcommande();
transmission();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComPort1RxChar(TObject *Sender, int Count)
{

// on arrive ici quand on reoit des donnes du port COM
index_transmission --;
try
{

unsigned char *datarecu = new unsigned char [Count];
ComPort1->Read(datarecu, Count);
// Lit "Count" octet(s) prsent(s) dans le buffer d'entre et le(s) place dans "datarecu"
// Normalement, on ne reoit qu'un seul octet du PIC

if (ReadData == 1)
{
        ReadData = 0; // drapeau remis  0
        EditReadData -> Text = IntToHex(datarecu[0],2);
}
else
{
        EditAdresCounter -> Text = IntToHex(datarecu[0],2);
}

delete [] datarecu;
datarecu = NULL;

}

catch(...)
{
Application->MessageBox("Erreur de rception !","Erreur 08",MB_OK);
}
}
//---------------------------------------------------------------------------



void __fastcall TForm1::ButtonReadAdressCounterClick(TObject *Sender)
{
// Read Address Counter

RS=0;
RW=1;
DB[7]=0;
DB[6]=0;
DB[5]=0;
DB[4]=0;
DB[3]=0;
DB[2]=0;
DB[1]=0;
DB[0]=0;
bitcommande();
transmission();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonReadDataClick(TObject *Sender)
{
// Read data
ReadData = 1; // drapeau mis  1
RS=1;
RW=1;
DB[7]=0;
DB[6]=0;
DB[5]=0;
DB[4]=0;
DB[3]=0;
DB[2]=0;
DB[1]=0;
DB[0]=0;
bitcommande();
transmission();
}
//---------------------------------------------------------------------------


